"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _rax = require("rax");

var _raxPicture = _interopRequireDefault(require("rax-picture"));

var _raxView = _interopRequireDefault(require("rax-view"));

var _raxText = _interopRequireDefault(require("rax-text"));

var _raxLink = _interopRequireDefault(require("rax-link"));

var _style = _interopRequireDefault(require("./style"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Card =
/*#__PURE__*/
function (_Component) {
  _inherits(Card, _Component);

  function Card() {
    _classCallCheck(this, Card);

    return _possibleConstructorReturn(this, _getPrototypeOf(Card).apply(this, arguments));
  }

  _createClass(Card, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      return !nextProps.dataSource || nextProps.dataSource[0].itemId !== this.props.dataSource[0].itemId;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          dataSource = _this$props.dataSource,
          otherProps = _objectWithoutProperties(_this$props, ["dataSource"]);

      if (dataSource.length === 0) {
        return null;
      }

      var returnDOM = dataSource.map(function (item, index) {
        var titleLineClamp = item.titleLineClamp ? item.titleLineClamp : 1;
        var subTitleLineClamp = item.subTitleLineClamp ? item.subTitleLineClamp : 1;
        var descLineClamp = item.descLineClamp ? item.descLineClamp : 1;
        return (0, _rax.createElement)(_raxLink.default, _extends({
          key: index,
          href: item.url,
          style: _style.default.itemwrap
        }, otherProps), (0, _rax.createElement)(_raxView.default, {
          style: _style.default.item
        }, (0, _rax.createElement)(_raxPicture.default, {
          source: {
            uri: item.pic
          },
          style: _style.default.pic
        }), (0, _rax.createElement)(_raxView.default, {
          style: _style.default.content
        }, (0, _rax.createElement)(_raxView.default, {
          style: _style.default.textwrap
        }, (0, _rax.createElement)(_raxText.default, {
          numberOfLines: titleLineClamp,
          style: _style.default.title
        }, item.title), item.subTitle ? (0, _rax.createElement)(_raxText.default, {
          numberOfLines: subTitleLineClamp,
          style: _style.default.subtitle
        }, item.subTitle) : null, item.desc ? (0, _rax.createElement)(_raxText.default, {
          numberOfLines: descLineClamp,
          style: _style.default.desc
        }, item.desc) : null), (0, _rax.createElement)(_raxView.default, {
          style: _style.default.sign
        }, item.price ? (0, _rax.createElement)(_raxText.default, {
          style: _style.default.highlightext
        }, item.price) : null, item.discount ? (0, _rax.createElement)(_raxText.default, {
          style: _style.default.weakentext
        }, item.discount) : null), item.extra ? (0, _rax.createElement)(_raxText.default, {
          style: _style.default.extratext
        }, item.extra) : null, item.tagging ? (0, _rax.createElement)(_raxText.default, {
          style: _style.default.tagtext
        }, item.tagging) : null)));
      });
      return (0, _rax.createElement)(_raxView.default, {
        style: _style.default.container
      }, returnDOM);
    }
  }]);

  return Card;
}(_rax.Component);

var _default = Card;
exports.default = _default;
module.exports = exports["default"];